#include <math.h>
#include <stdio.h>

extern "C" {


#include <g2.h>
#include <g2_PS.h>
#include <g2_X11.h>
#include <g2_PS.h>
} /* extern C */

#include "qad.h"


t_vec
pers(t_vec v, double cenx, double ceny)
{
  t_vec ret;

  ret[0] = (v[0] + v[2] * .6 - cenx) / (v[3] + 1) + cenx;
  ret[1] = (v[1] + v[2] * .3 - ceny) / (v[3] + 1) + ceny;

  ret[0] *= 100.0;
  ret[1] *= 100.0;

  ret[0] += 40;
  ret[1] += 40;

  return ret;
}

void
draw_zline(
  int id,
  double x0, double y0,  double z0, 
  double x1, double y1,  double z1) 
{
  int pen;

} /* draw_zline */
  //mm75.rotxy( (75.522487814070076121228965200840 * M_PI)/ 180);

void
draw_edge(int dev_id, t_vec p0, t_vec p1)
{
#define vec2x(p) ( p[0]*100 + 60*p[2] + 20*p[3] + 50)
#define vec2y(p) ( p[1]*100 + 20*p[2] + 70*p[3] + 2)
  t_vec pp0, pp1;

  pp0 = pers(p0, .5, .5);
  pp1 = pers(p1, .5, .5);
 
  g2_line(dev_id, pp0[0], pp0[1], pp1[0], pp1[1]);
  //g2_line(dev_id, vec2x(p0), vec2y(p0), vec2x(p1), vec2y(p1));
} /* draw_one */


/*
 * popis 
 */

void
draw_by_g2(int dev_id, t_hr &hr)
{
  t_vec p0, p1;
  /* vytisknu sebe a pak vsechny sve potomky */

  p0 = hr.pos0();
  p1 = hr.pos();

  draw_edge(dev_id, p0, p1);
  cout << p0 << " --> "<< p1 << "\n";
  for(int i=4;i--;)
  {
    if( hr.ups[i] != NULL )
    {
     if(i) cout << "<down>\n";
     draw_by_g2(dev_id, *hr.ups[i]);
     if(i)cout << "</down>\n";
    }
  }
} /* draw_by_g2 */



double &
t_vec::operator[](int i)
{
  if( i < 0 || i >= EDIM )
  {
    i = 0;
  }
  return v[i];
} /* op [] */

double *
t_mat::operator[](int i)
{
  if( i < 0 || i >= EDIM )
  {
    i = 0;
  }
  return &m[EDIM * i];
} /* op [] */

t_mat
t_mat::operator *(t_mat &mat)
{
#define M(a,b) m[EDIM*(a)+(b)]
  int i,j,k;
  t_mat ret;
  double sum;
  for(i = EDIM; i--;)
  for(j = EDIM; j--;)
  {
    sum = 0;
    for(k = EDIM; k--;)
    {
       sum +=  M(i,k) * mat.M(k,j);
    }
    ret[i][j] = sum;
  }
  return ret;
#undef M
} /* op t_mat * t_mat */

t_vec
t_vec::operator *(t_mat &mat)
{
  int i,j;
  t_vec ret;
  double sum; 

  for(i=EDIM; i--;) 
  {
    sum = 0;
    for(j=EDIM;j--;)
    {
      sum += v[j] * mat[j][i];
    }
    ret[i] = sum;
  }
  return ret;
} /* op t_vec * t_mat */
 
void
t_vec::zero()
{
  for(int i = EDIM - 1; i--;)v[i]=0;
  v[EDIM -1] = 1;
} /* t_mat::zero */

void
t_vec::e()
{
  for(int i = EDIM - 1; i--;)v[i]=0;
  v[EDIM -1] = 1;
  v[0] = 1;
} /* t_mat::zero */

void
t_mat::zero()
{
  for(int i = EDIM*EDIM; i--;)m[i]=0;
} /* t_mat::zero */

void
t_mat::e()
{
  for(int i = EDIM*EDIM; i--;)m[i]=0;
  for(int i = EDIM; i--;)m[EDIM*i+i]=1;
} /* t_mat::zero */


void
t_mat::rot0p(double alfa)
{
  double sa = sin(M_PI - alfa);
  double ca = cos(M_PI - alfa);

  e();
#define M(a,b) m[EDIM*(a)+(b)]
  M(0,0) =  ca;
  M(1,0) = -sa;

  M(0,1) =  sa;
  M(1,1) =  ca;

  M(4,0) = 1;
#undef M
} /* t_mat::rot0p */


void
t_mat::rotx(double alfa)
{
  double sa = sin(alfa);
  double ca = cos(alfa);

  e();
#define M(a,b) m[EDIM*(a)+(b)]
  M(1,1) =  ca;
  M(2,1) = -sa;

  M(1,2) =  sa;
  M(2,2) =  ca;
#undef M
} /* t_mat:rotx */

void
t_mat::rotxy(double alfa)
{
  double sa = sin(alfa);
  double ca = cos(alfa);

  e();
#define M(a,b) m[EDIM*(a)+(b)]
  M(2,2) =  ca;
  M(3,2) = -sa;

  M(2,3) =  sa;
  M(3,3) =  ca;
#undef M
} /* t_mat:rotx */


std::ostream&
t_vec::write(std::ostream& out)const
{

#define M(a,b) m[EDIM*(a)+(b)]

  int i;
  out << "[ " ;
  for(i = 0; i < EDIM;i++)
  {
    out.precision(4);
    if( v[i] < 0.000001)
    {
      out << 0. << " ";
    }
    else
    {
      out << v[i]<< " ";
    }
  }
  out << "]";

  return out;
} /* write */
std::ostream&
operator<<(std::ostream& out, const t_vec& v)
{
  return v.write(out);
} /* op << */

std::ostream&
t_mat::write(std::ostream& out)const
{

#define M(a,b) m[EDIM*(a)+(b)]

  int i,j;
  for(i = 0; i < EDIM;i++)
  {
    out << ( i ? "  " : "[ ") ;

    for(j = 0; j < EDIM;j++)
    {
      out.width(3);
      out << M(i,j) << " ";
    }
    out << "\n";
  }
  out << "]\n";

  return out;
} /* write */

std::ostream&
operator<<(std::ostream& out, const t_mat& m)
{
  return m.write(out);
} /* op << */

t_mat mat_e;

t_hr::t_hr(t_mat &m = mat_e, t_hr *d0 =NULL, t_hr *d1=NULL, t_hr *d2=NULL, t_hr *d3=NULL)
{
  ups[0] = d0;
  ups[1] = d1;
  ups[2] = d2;
  ups[3] = d3;

  if(d0) d0->dwn = this;
  if(d1) d1->dwn = this;
  if(d2) d2->dwn = this;
  if(d3) d3->dwn = this;

  dwn = NULL;
  mat = m;
} /* t_hr::t_hr */

t_hr*
t_hr::dup()
{
  return new t_hr(
   mat,
   ups[0]?ups[0]->dup():NULL,
   ups[1]?ups[1]->dup():NULL,
   ups[2]?ups[2]->dup():NULL,
   ups[3]?ups[3]->dup():NULL);
} /* t_hr::dup */

t_vec
t_hr::pos()
{
   t_hr *i;
   t_vec v;

   v.e();

   for(i = this; i; i = i->dwn)
   {
     v = v * i->mat;
   }
   return v;
} /* t_hr::pos */

t_vec
t_hr::pos0()
{
   t_hr *i;
   t_vec v;

   v.zero();

   for(i = this; i; i = i->dwn)
   {
     v = v * i->mat;
   }
   return v;
} /* t_hr::pos */

t_hr*
t_hr::operator[](int at)
{
  t_hr *h;
  int i;

  for(h= this, i = at; i--;h= h->ups[0])
  {
    if(!h)
    {
      printf("t_hr[]:prelezlo posledniho(%iteho)\n", at - i - 1);
      return NULL;
    }
  }
  return h;
} /* op [] */

t_hr *
build_polygon(int N)
{
  t_mat m;
  t_hr  *nxt, *fst;
  int i;

  m.rot0p( M_PI * (double)(N - 2.) / (double)N );
  //cout<<m;

  nxt = new t_hr;

  for(i=N;i--;)
  {
    fst = new t_hr;
    (*nxt)(m, fst);
    nxt = fst;
    
  }
  return fst;

} /* build_polygon */

int
main()
{

  t_hr h1, h2, h3, h4, h5, h6;
  t_hr *hh;
  t_hr *hh0, *hh1, *hh2, *hh3, *hh4, *hh5, *hh6;
  t_hr *hh7, *hh8, *hh9;

  t_mat m60, m70, m90, mm90, m116, m116o, mm75, mm75o;

  int devid;


  //devid = g2_open_PS("out.ps", g2_A4, g2_PS_land);
  devid = g2_open_X11(500, 500);



  m60.rot0p(60*M_PI/180);
  m70.rotx(70.528779 * M_PI/180);

  m90.rotx(90 * M_PI/180);
  m116.rotx( (116.565051177077989351572193720642 * M_PI) / 180);
  m116o.rotx( (-116.565051177077989351572193720642 * M_PI) / 180);

  mm75.rotxy( (75.522487814070076121228965200840 * M_PI)/ 180);
  mm75o.rotxy( (75.522487814070076121228965200840 * M_PI)/ 180);
  mm90.rotxy(90 * M_PI/180);


#if 1
/* trojuhelnik */
  hh = build_polygon(3);

  hh0 = hh->dup();
  hh1 = hh->dup();
  hh2 = hh->dup();
  hh3 = hh->dup();
  hh4 = hh->dup();

  (*hh0)(m70, (*hh)[0], 1); 
  (*hh1)(m70, (*hh)[1], 1); 

  hh0 = hh->dup();
  hh1 = hh->dup();

  (*hh0)(mm75, hh, 2);
  (*hh1)(mm75o, (*hh)[1]->ups[1], 2);
  cout<<mm75;
#endif




#if 0
/* ctverec */

  hh = build_polygon(4);
  hh0 = hh->dup();
  hh1 = hh->dup();
  hh2 = hh->dup();
  hh3 = hh->dup();

  (*hh0)(m90, (*hh)[0], 1); 
  (*hh1)(m90, (*hh)[1], 1); 
  (*hh2)(m90, (*hh)[2], 1); 
  (*hh3)(m90, (*hh)[3], 1); 

  hh0 = hh->dup();
  hh1 = hh->dup();
  hh2 = hh->dup();
  hh3 = hh->dup();
  hh4 = hh->dup();

  (*hh0)(mm90, hh, 2);
  (*hh1)(mm90, (*hh)[0]->ups[1], 2);
  (*hh2)(mm90, (*hh)[1]->ups[1], 2);
  (*hh3)(mm90, (*hh)[2]->ups[1], 2);
  (*hh4)(mm90, (*hh)[3]->ups[1], 2);

#endif

#if 0
/* dvanacti sten */

  hh = build_polygon(5);

  hh0 = hh->dup();
  hh1 = hh->dup();
  hh2 = hh->dup();
  hh3 = hh->dup();
  hh4 = hh->dup();

  hh5 = hh->dup();
  hh6 = hh->dup();
  hh7 = hh->dup();
  hh8 = hh->dup();
  hh9 = hh->dup();

  (*hh0)(m116, (*hh)[0], 1); 
  (*hh1)(m116, (*hh)[1], 1); 
  (*hh2)(m116, (*hh)[2], 1); 
  (*hh3)(m116, (*hh)[3], 1); 
  (*hh4)(m116, (*hh)[4], 1); 

  //hh0 = hh->dup();
  //hh1 = hh->dup();
  //hh2 = hh->dup();
  //hh3 = hh->dup();
  //hh4 = hh->dup();


  (*hh5)(m116o, (*(*hh)[0]->ups[1])[2], 1);
  (*hh6)(m116o, (*(*hh)[1]->ups[1])[2], 1);
  (*hh7)(m116o, (*(*hh)[2]->ups[1])[2], 1);
  (*hh8)(m116o, (*(*hh)[3]->ups[1])[2], 1);
  (*hh9)(m116o, (*(*hh)[4]->ups[1])[2], 1);

#if 0
  hh0 = hh->dup();
  hh1 = hh->dup();
  hh2 = hh->dup();
  hh3 = hh->dup();

  (*hh0)(mm90, hh, 2);
  (*hh1)(mm90, (*hh)[0]->ups[1], 2);
  (*hh1)(mm90, (*hh)[1]->ups[1], 2);
  (*hh2)(mm90, (*hh)[2]->ups[1], 2);
  (*hh3)(mm90, (*hh)[3]->ups[1], 2);
#endif

  //draw_by_g2(devid, *hh2);

#endif

  cout<<"\n--------\n";

  draw_by_g2(devid, *hh);
#if 0
  m60.rot0p(60*M_PI/180);
  m70.rotx(70.528779 * M_PI/180);

  h3(m60, h2);
  h2(m60, h1);

  h5 = *h1.dup();
  (*h1.dup())(m70, h4, 1);

  draw_by_g2(h1, 0);

  cout << "-----\n";
  draw_by_g2(h5, 0);

  cout << m70;
  cout << "h1[0][0]" << h1[0][0].pos();
  cout << "h1" << h1.pos();
  cout << "h2" << h2.pos();
  cout << "h3" << h3.pos();
  cout << "h4" << h4.pos();
  cout << "h4[1][0]" << h4[1][0][0].pos();
  cout << "h5[0][0]" << h5[0][0].pos();
  cout << "h6" << h6.pos();
  cout << "--" << (*h1.dup())[0][0].pos();
  cout << "--'" << h1.dup()->ups[0]->ups[0]->pos();
#endif
  getchar();
} /* main */

